## @file
# @copyright
# Copyright 2019 - 2021 Intel Corporation. <BR>
#
# SPDX-License-Identifier: BSD-2-Clause-Patent
##

[Defines]
  VPD_TOOL_GUID                  = 8C3D856A-9BE6-468E-850A-24F7A8D38E08

[SkuIds]
  0|DEFAULT              # The entry: 0|DEFAULT is reserved and always required.

[DefaultStores]
  0|STANDARD             # UEFI Standard default  0|STANDARD is reserved.
  1|MANUFACTURING        # UEFI Manufacturing default 1|MANUFACTURING is reserved.

[PcdsDynamicExVpd.common.DEFAULT]
  gEfiMdeModulePkgTokenSpaceGuid.PcdNvStoreDefaultValueBuffer|*

[PcdsDynamicExHii.common.DEFAULT.STANDARD]
gStructPcdTokenSpaceGuid.PcdFpgaSocketConfig|L"FpgaSocketConfig"|gFpgaSocketVariableGuid|0x00||NV, BS, RT
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig|L"SocketMemoryConfig"|gEfiSocketMemoryVariableGuid|0x00||NV, BS, RT
gStructPcdTokenSpaceGuid.PcdPchSetup|L"PchSetup"|gPchSetupVariableGuid|0x00||NV, BS, RT
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig|L"SocketProcessorCoreConfig"|gEfiSocketProcessorCoreVarGuid|0x00||NV, BS, RT
gStructPcdTokenSpaceGuid.PcdSetup|L"Setup"|gCommonSystemConfigurationGuid|0x00||NV, BS, RT
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig|L"SocketCommonRcConfig"|gEfiSocketCommonRcVariableGuid|0x00||NV, BS, RT
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig|L"SocketPowerManagementConfig"|gEfiSocketPowermanagementVarGuid|0x00||NV, BS, RT
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig|L"SocketMpLinkConfig"|gEfiSocketMpLinkVariableGuid|0x00||NV, BS, RT
gStructPcdTokenSpaceGuid.PcdSocketIioConfig|L"SocketIioConfig"|gEfiSocketIioVariableGuid|0x00||NV, BS, RT

!if $(TARGET) == "DEBUG"
gStructPcdTokenSpaceGuid.PcdSetup.serialDebugMsgLvl|0x4
gStructPcdTokenSpaceGuid.PcdSetup.serialDebugMsgLvlTrainResults|0x8
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.DebugPrintLevel|0xF
!else
gStructPcdTokenSpaceGuid.PcdSetup.serialDebugMsgLvl|0x0
gStructPcdTokenSpaceGuid.PcdSetup.serialDebugMsgLvlTrainResults|0x0
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.DebugPrintLevel|0x0
!endif

gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ATS|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[0]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[1]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[2]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[3]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[4]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[5]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[6]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[7]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[8]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[9]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[10]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[11]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[12]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[13]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[14]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[15]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[16]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[17]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[18]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[19]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[20]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[21]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[22]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[23]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[24]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[25]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[26]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[27]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[28]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[29]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[30]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[31]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.CbDmaMultiCastEnable|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.CoherencySupport|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.CompletionTimeoutGlobal|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.CompletionTimeoutGlobalValue|0x9
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.CompletionTimeoutValue[0]|0x9
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.CompletionTimeoutValue[1]|0x9
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.CompletionTimeoutValue[2]|0x9
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.CompletionTimeoutValue[3]|0x9
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ConfigIOU0[0]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ConfigIOU0[1]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ConfigIOU0[2]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ConfigIOU0[3]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ConfigIOU1[0]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ConfigIOU1[1]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ConfigIOU1[2]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ConfigIOU1[3]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ConfigIOU2[0]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ConfigIOU2[1]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ConfigIOU2[2]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ConfigIOU2[3]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ConfigIOU3[0]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ConfigIOU3[1]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ConfigIOU3[2]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ConfigIOU3[3]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ConfigIOU4[0]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ConfigIOU4[1]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ConfigIOU4[2]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ConfigIOU4[3]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[1]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[2]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[3]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[4]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[5]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[6]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[7]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[8]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[9]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[10]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[11]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[12]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[13]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[14]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[15]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[16]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[17]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[18]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[19]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[20]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[21]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[22]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[23]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[24]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[25]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[26]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[27]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[28]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[29]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[30]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[31]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[32]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[33]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[34]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[35]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[36]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[37]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[38]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[39]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[40]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[41]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[42]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[43]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[44]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[45]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[46]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[47]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[48]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[49]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[50]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[51]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[52]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[53]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[54]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[55]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[56]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[57]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[58]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[59]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[60]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[61]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[62]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[63]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[64]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[65]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[66]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[67]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[68]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[69]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[70]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[71]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[72]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[73]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[74]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[75]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[76]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[77]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[78]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[79]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[80]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[81]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[82]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DeEmphasis[83]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DevPresIoApicIio[0]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DevPresIoApicIio[1]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DevPresIoApicIio[2]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DevPresIoApicIio[3]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DevPresIoApicIio[4]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DevPresIoApicIio[5]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DevPresIoApicIio[6]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DevPresIoApicIio[7]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DevPresIoApicIio[8]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DevPresIoApicIio[9]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DevPresIoApicIio[10]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DevPresIoApicIio[11]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DevPresIoApicIio[12]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DevPresIoApicIio[13]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DevPresIoApicIio[14]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DevPresIoApicIio[15]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DevPresIoApicIio[16]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DevPresIoApicIio[17]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DevPresIoApicIio[18]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DevPresIoApicIio[19]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DevPresIoApicIio[20]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DevPresIoApicIio[21]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DevPresIoApicIio[22]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DevPresIoApicIio[23]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS19|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[0]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[1]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[2]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[3]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[4]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[5]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[6]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[7]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[8]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[9]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[10]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[11]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[12]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[13]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[14]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[15]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[16]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[17]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[18]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[19]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[20]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[21]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[22]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[23]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[24]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[25]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[26]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[27]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[28]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[29]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[30]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[31]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[32]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[33]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[34]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[35]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[36]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[37]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[38]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[39]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[40]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[41]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[42]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[43]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[44]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[45]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[46]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[47]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[48]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[49]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[50]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[51]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[52]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[53]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[54]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[55]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[56]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[57]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[58]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[59]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[60]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[61]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[62]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[63]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[64]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[65]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[66]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[67]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[68]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[69]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[70]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[71]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[72]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[73]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[74]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[75]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[76]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[77]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[78]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[79]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[80]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[81]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[82]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS39[83]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[0]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[1]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[2]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[3]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[4]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[5]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[6]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[7]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[8]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[9]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[10]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[11]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[12]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[13]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[14]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[15]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[16]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[17]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[18]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[19]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[20]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[21]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[22]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[23]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[24]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[25]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[26]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[27]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[28]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[29]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[30]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[31]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[32]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[33]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[34]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[35]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[36]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[37]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[38]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[39]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[40]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[41]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[42]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[43]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[44]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[45]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[46]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[47]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[48]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[49]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[50]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[51]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[52]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[53]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[54]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[55]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[56]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[57]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[58]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[59]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[60]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[61]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[62]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[63]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[64]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[65]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[66]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[67]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[68]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[69]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[70]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[71]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[72]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[73]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[74]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[75]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[76]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[77]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[78]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[79]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[80]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[81]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[82]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS26[83]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[0]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[1]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[2]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[3]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[4]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[5]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[6]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[7]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[8]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[9]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[10]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[11]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[12]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[13]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[14]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[15]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[16]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[17]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[18]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[19]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[20]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[21]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[22]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[23]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[24]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[25]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[26]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[27]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[28]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[29]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[30]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[31]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[32]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[33]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[34]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[35]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[36]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[37]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[38]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[39]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[40]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[41]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[42]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[43]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[44]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[45]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[46]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[47]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[48]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[49]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[50]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[51]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[52]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[53]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[54]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[55]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[56]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[57]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[58]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[59]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[60]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[61]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[62]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[63]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[64]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[65]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[66]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[67]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[68]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[69]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[70]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[71]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[72]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[73]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[74]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[75]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[76]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[77]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[78]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[79]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[80]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[81]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[82]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS27[83]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[0]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[1]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[2]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[3]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[4]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[5]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[6]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[7]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[8]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[9]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[10]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[11]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[12]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[13]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[14]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[15]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[16]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[17]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[18]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[19]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[20]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[21]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[22]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[23]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[24]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[25]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[26]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[27]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[28]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[29]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[30]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[31]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[32]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[33]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[34]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[35]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[36]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[37]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[38]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[39]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[40]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[41]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[42]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[43]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[44]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[45]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[46]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[47]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[48]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[49]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[50]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[51]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[52]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[53]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[54]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[55]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[56]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[57]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[58]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[59]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[60]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[61]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[62]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[63]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[64]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[65]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[66]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[67]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[68]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[69]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[70]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[71]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[72]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[73]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[74]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[75]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[76]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[77]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[78]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[79]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[80]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[81]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[82]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS25[83]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[0]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[1]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[2]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[3]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[4]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[5]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[6]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[7]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[8]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[9]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[10]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[11]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[12]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[13]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[14]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[15]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[16]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[17]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[18]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[19]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[20]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[21]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[22]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[23]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[24]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[25]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[26]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[27]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[28]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[29]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[30]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[31]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[32]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[33]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[34]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[35]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[36]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[37]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[38]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[39]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[40]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[41]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[42]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[43]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[44]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[45]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[46]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[47]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[48]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[49]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[50]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[51]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[52]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[53]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[54]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[55]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[56]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[57]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[58]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[59]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[60]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[61]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[62]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[63]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[64]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[65]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[66]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[67]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[68]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[69]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[70]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[71]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[72]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[73]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[74]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[75]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[76]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[77]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[78]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[79]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[80]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[81]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[82]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS29[83]|0x29
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[0]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[1]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[2]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[3]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[4]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[5]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[6]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[7]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[8]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[9]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[10]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[11]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[12]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[13]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[14]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[15]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[16]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[17]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[18]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[19]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[20]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[21]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[22]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[23]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[24]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[25]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[26]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[27]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[28]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[29]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[30]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[31]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[32]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[33]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[34]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[35]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[36]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[37]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[38]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[39]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[40]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[41]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[42]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[43]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[44]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[45]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[46]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[47]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[48]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[49]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[50]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[51]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[52]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[53]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[54]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[55]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[56]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[57]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[58]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[59]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[60]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[61]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[62]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[63]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[64]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[65]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[66]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[67]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[68]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[69]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[70]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[71]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[72]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[73]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[74]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[75]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[76]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[77]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[78]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[79]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[80]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[81]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[82]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS30[83]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[0]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[1]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[2]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[3]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[4]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[5]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[6]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[7]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[8]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[9]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[10]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[11]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[12]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[13]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[14]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[15]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[16]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[17]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[18]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[19]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[20]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[21]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[22]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[23]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[24]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[25]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[26]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[27]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[28]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[29]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[30]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[31]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[32]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[33]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[34]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[35]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[36]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[37]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[38]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[39]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[40]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[41]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[42]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[43]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[44]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[45]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[46]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[47]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[48]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[49]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[50]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[51]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[52]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[53]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[54]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[55]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[56]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[57]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[58]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[59]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[60]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[61]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[62]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[63]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[64]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[65]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[66]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[67]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[68]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[69]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[70]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[71]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[72]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[73]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[74]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[75]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[76]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[77]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[78]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[79]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[80]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[81]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[82]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS28[83]|0xB
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS17|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS16|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS14|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS13|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS12|0x99
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS18|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[0]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[1]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[2]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[3]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[4]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[5]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[6]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[7]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[8]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[9]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[10]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[11]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[12]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[13]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[14]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[15]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[16]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[17]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[18]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[19]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[20]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[21]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[22]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[23]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[24]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[25]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[26]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[27]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[28]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[29]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[30]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[31]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[32]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[33]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[34]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[35]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[36]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[37]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[38]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[39]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[40]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[41]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[42]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[43]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[44]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[45]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[46]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[47]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[48]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[49]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[50]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[51]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[52]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[53]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[54]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[55]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[56]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[57]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[58]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[59]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[60]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[61]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[62]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[63]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[64]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[65]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[66]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[67]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[68]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[69]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[70]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[71]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[72]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[73]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[74]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[75]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[76]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[77]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[78]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[79]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[80]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[81]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[82]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS40[83]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[0]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[1]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[2]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[3]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[4]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[5]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[6]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[7]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[8]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[9]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[10]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[11]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[12]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[13]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[14]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[15]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[16]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[17]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[18]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[19]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[20]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[21]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[22]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[23]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[24]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[25]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[26]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[27]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[28]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[29]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[30]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[31]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[32]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[33]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[34]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[35]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[36]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[37]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[38]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[39]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[40]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[41]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[42]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[43]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[44]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[45]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[46]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[47]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[48]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[49]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[50]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[51]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[52]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[53]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[54]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[55]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[56]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[57]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[58]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[59]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[60]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[61]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[62]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[63]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[64]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[65]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[66]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[67]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[68]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[69]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[70]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[71]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[72]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[73]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[74]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[75]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[76]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[77]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[78]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[79]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[80]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[81]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[82]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.ReservedS41[83]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DmiAllocatingFlow|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.DualCvIoFlow|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[1]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[2]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[3]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[4]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[5]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[6]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[7]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[8]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[9]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[10]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[11]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[12]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[13]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[14]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[15]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[16]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[17]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[18]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[19]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[20]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[21]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[22]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[23]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[24]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[25]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[26]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[27]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[28]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[29]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[30]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[31]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[32]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[33]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[34]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[35]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[36]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[37]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[38]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[39]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[40]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[41]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[42]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[43]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[44]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[45]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[46]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[47]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[48]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[49]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[50]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[51]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[52]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[53]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[54]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[55]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[56]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[57]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[58]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[59]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[60]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[61]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[62]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[63]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[64]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[65]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[66]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[67]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[68]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[69]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[70]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[71]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[72]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[73]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[74]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[75]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[76]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[77]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[78]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[79]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[80]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[81]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[82]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.EOI[83]|0x0
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[0]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[1]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[2]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[3]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[4]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[5]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[6]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[7]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[8]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[9]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[10]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[11]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[12]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[13]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[14]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[15]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[16]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[17]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[18]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[19]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[20]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[21]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[22]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[23]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[24]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[25]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[26]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[27]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[28]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[29]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[30]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[31]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[32]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[33]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[34]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[35]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[36]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[37]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[38]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[39]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[40]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[41]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[42]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[43]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[44]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[45]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[46]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[47]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[48]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[49]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[50]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[51]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[52]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[53]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[54]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[55]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[56]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[57]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[58]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[59]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[60]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[61]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[62]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[63]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[64]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[65]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[66]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[67]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[68]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[69]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[70]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[71]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[72]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[73]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[74]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[75]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[76]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[77]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[78]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[79]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[80]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[81]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[82]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.HidePEXPMenu[83]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.InterruptRemap|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[0]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[1]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[2]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[3]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[4]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[5]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[6]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[7]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[8]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[9]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[10]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[11]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[12]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[13]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[14]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[15]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[16]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[17]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[18]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[19]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[20]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[21]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[22]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[23]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[24]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[25]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[26]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[27]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[28]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[29]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[30]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[31]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[32]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[33]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[34]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[35]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[36]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[37]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[38]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[39]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[40]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[41]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[42]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[43]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[44]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[45]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[46]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[47]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[48]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[49]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[50]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[51]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[52]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[53]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[54]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[55]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[56]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[57]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[58]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[59]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[60]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[61]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[62]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[63]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[64]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[65]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[66]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[67]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[68]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[69]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[70]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[71]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[72]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[73]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[74]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[75]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[76]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[77]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[78]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[79]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[80]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[81]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[82]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.IODC[83]|0x6
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.McastIndexPosition|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.McastNumGroup|0x8
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[0]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[1]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[2]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[3]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[4]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[5]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[6]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[7]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[8]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[9]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[10]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[11]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[12]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[13]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[14]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[15]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[16]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[17]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[18]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[19]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[20]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[21]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[22]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[23]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[24]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[25]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[26]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[27]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[28]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[29]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[30]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[31]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[32]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[33]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[34]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[35]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[36]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[37]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[38]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[39]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[40]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[41]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[42]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[43]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[44]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[45]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[46]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[47]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[48]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[49]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[50]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[51]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[52]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[53]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[54]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[55]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[56]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[57]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[58]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[59]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[60]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[61]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[62]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[63]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[64]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[65]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[66]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[67]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[68]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[69]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[70]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[71]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[72]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[73]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[74]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[75]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[76]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[77]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[78]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[79]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[80]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[81]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[82]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.MctpEn[83]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NoSnoopWrCfg|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ1[0]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ1[1]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ1[2]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ1[3]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ1[4]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ1[5]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ1[6]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ1[7]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ1[8]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ1[9]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ1[10]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ1[11]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ1[12]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ1[13]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ1[14]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ1[15]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ1[16]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ1[17]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ1[18]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ1[19]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2[0]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2[1]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2[2]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2[3]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2[4]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2[5]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2[6]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2[7]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2[8]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2[9]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2[10]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2[11]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2[12]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2[13]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2[14]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2[15]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2[16]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2[17]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2[18]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2[19]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_0[0]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_0[1]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_0[2]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_0[3]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_0[4]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_0[5]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_0[6]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_0[7]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_0[8]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_0[9]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_0[10]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_0[11]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_0[12]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_0[13]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_0[14]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_0[15]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_0[16]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_0[17]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_0[18]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_0[19]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_1[0]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_1[1]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_1[2]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_1[3]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_1[4]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_1[5]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_1[6]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_1[7]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_1[8]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_1[9]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_1[10]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_1[11]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_1[12]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_1[13]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_1[14]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_1[15]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_1[16]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_1[17]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_1[18]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeEmBarSZ2_1[19]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar1[0]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar1[1]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar1[2]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar1[3]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar1[4]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar1[5]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar1[6]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar1[7]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar1[8]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar1[9]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar1[10]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar1[11]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar1[12]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar1[13]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar1[14]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar1[15]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar1[16]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar1[17]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar1[18]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar1[19]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2[0]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2[1]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2[2]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2[3]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2[4]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2[5]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2[6]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2[7]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2[8]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2[9]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2[10]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2[11]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2[12]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2[13]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2[14]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2[15]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2[16]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2[17]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2[18]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2[19]|0x16
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_0[0]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_0[1]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_0[2]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_0[3]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_0[4]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_0[5]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_0[6]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_0[7]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_0[8]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_0[9]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_0[10]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_0[11]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_0[12]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_0[13]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_0[14]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_0[15]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_0[16]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_0[17]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_0[18]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_0[19]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_1[0]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_1[1]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_1[2]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_1[3]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_1[4]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_1[5]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_1[6]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_1[7]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_1[8]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_1[9]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_1[10]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_1[11]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_1[12]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_1[13]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_1[14]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_1[15]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_1[16]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_1[17]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_1[18]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbBarSizeImBar2_1[19]|0xC
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbLinkBiosTrainEn|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbXlinkCtlOverride[0]|0x3
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbXlinkCtlOverride[1]|0x3
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbXlinkCtlOverride[2]|0x3
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbXlinkCtlOverride[3]|0x3
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbXlinkCtlOverride[4]|0x3
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbXlinkCtlOverride[5]|0x3
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbXlinkCtlOverride[6]|0x3
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbXlinkCtlOverride[7]|0x3
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbXlinkCtlOverride[8]|0x3
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbXlinkCtlOverride[9]|0x3
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbXlinkCtlOverride[10]|0x3
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbXlinkCtlOverride[11]|0x3
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbXlinkCtlOverride[12]|0x3
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbXlinkCtlOverride[13]|0x3
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbXlinkCtlOverride[14]|0x3
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbXlinkCtlOverride[15]|0x3
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbXlinkCtlOverride[16]|0x3
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbXlinkCtlOverride[17]|0x3
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbXlinkCtlOverride[18]|0x3
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.NtbXlinkCtlOverride[19]|0x3
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Pci64BitResourceAllocation|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PCIe_LTR|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAllocatingFlow|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[0]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[1]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[2]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[3]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[4]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[5]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[6]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[7]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[8]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[9]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[10]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[11]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[12]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[13]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[14]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[15]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[16]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[17]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[18]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[19]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[20]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[21]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[22]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[23]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[24]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[25]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[26]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[27]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[28]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[29]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[30]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[31]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[32]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[33]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[34]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[35]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[36]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[37]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[38]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[39]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[40]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[41]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[42]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[43]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[44]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[45]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[46]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[47]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[48]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[49]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[50]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[51]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[52]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[53]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[54]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[55]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[56]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[57]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[58]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[59]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[60]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[61]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[62]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[63]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[64]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[65]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[66]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[67]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[68]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[69]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[70]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[71]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[72]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[73]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[74]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[75]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[76]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[77]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[78]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[79]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[80]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[81]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[82]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieAspm[83]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieBiosTrainEnable|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[0]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[1]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[2]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[3]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[4]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[5]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[6]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[7]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[8]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[9]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[10]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[11]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[12]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[13]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[14]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[15]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[16]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[17]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[18]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[19]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[20]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[21]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[22]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[23]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[24]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[25]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[26]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[27]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[28]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[29]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[30]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[31]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[32]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[33]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[34]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[35]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[36]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[37]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[38]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[39]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[40]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[41]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[42]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[43]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[44]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[45]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[46]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[47]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[48]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[49]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[50]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[51]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[52]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[53]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[54]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[55]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[56]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[57]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[58]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[59]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[60]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[61]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[62]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[63]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[64]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[65]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[66]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[67]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[68]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[69]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[70]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[71]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[72]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[73]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[74]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[75]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[76]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[77]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[78]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[79]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[80]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[81]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[82]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieCommonClock[83]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[0]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[1]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[2]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[3]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[4]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[5]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[6]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[7]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[8]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[9]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[10]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[11]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[12]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[13]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[14]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[15]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[16]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[17]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[18]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[19]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[20]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[21]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[22]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[23]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[24]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[25]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[26]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[27]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[28]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[29]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[30]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[31]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[32]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[33]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[34]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[35]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[36]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[37]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[38]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[39]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[40]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[41]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[42]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[43]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[44]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[45]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[46]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[47]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[48]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[49]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[50]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[51]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[52]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[53]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[54]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[55]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[56]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[57]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[58]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[59]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[60]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[61]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[62]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[63]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[64]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[65]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[66]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[67]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[68]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[69]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[70]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[71]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[72]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[73]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[74]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[75]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[76]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[77]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[78]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[79]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[80]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[81]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[82]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieDataLinkFeatureExchangeEnable[83]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieExtendedTagField|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieGlobalAspm|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[0]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[1]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[2]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[3]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[4]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[5]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[6]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[7]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[8]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[9]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[10]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[11]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[12]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[13]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[14]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[15]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[16]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[17]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[18]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[19]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[20]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[21]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[22]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[23]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[24]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[25]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[26]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[27]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[28]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[29]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[30]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[31]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[32]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[33]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[34]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[35]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[36]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[37]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[38]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[39]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[40]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[41]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[42]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[43]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[44]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[45]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[46]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[47]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[48]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[49]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[50]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[51]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[52]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[53]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[54]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[55]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[56]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[57]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[58]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[59]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[60]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[61]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[62]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[63]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[64]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[65]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[66]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[67]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[68]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[69]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[70]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[71]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[72]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[73]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[74]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[75]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[76]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[77]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[78]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[79]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[80]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[81]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[82]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieL1Latency[83]|0x4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[0]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[1]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[2]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[3]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[4]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[5]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[6]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[7]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[8]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[9]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[10]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[11]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[12]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[13]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[14]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[15]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[16]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[17]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[18]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[19]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[20]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[21]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[22]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[23]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[24]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[25]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[26]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[27]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[28]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[29]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[30]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[31]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[32]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[33]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[34]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[35]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[36]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[37]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[38]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[39]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[40]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[41]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[42]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[43]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[44]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[45]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[46]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[47]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[48]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[49]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[50]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[51]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[52]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[53]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[54]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[55]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[56]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[57]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[58]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[59]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[60]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[61]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[62]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[63]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[64]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[65]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[66]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[67]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[68]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[69]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[70]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[71]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[72]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[73]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[74]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[75]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[76]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[77]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[78]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[79]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[80]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[81]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[82]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxPayload[83]|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieMaxReadRequestSize|0x7
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[0]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[1]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[2]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[3]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[4]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[5]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[6]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[7]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[8]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[9]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[10]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[11]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[12]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[13]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[14]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[15]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[16]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[17]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[18]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[19]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[20]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[21]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[22]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[23]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[24]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[25]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[26]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[27]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[28]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[29]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[30]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[31]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[32]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[33]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[34]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[35]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[36]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[37]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[38]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[39]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[40]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[41]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[42]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[43]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[44]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[45]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[46]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[47]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[48]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[49]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[50]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[51]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[52]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[53]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[54]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[55]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[56]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[57]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[58]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[59]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[60]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[61]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[62]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[63]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[64]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[65]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[66]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[67]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[68]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[69]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[70]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[71]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[72]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[73]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[74]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[75]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[76]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[77]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[78]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[79]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[80]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[81]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[82]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortClkGateEnable[83]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[1]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[2]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[3]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[4]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[5]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[6]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[7]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[8]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[9]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[10]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[11]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[12]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[13]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[14]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[15]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[16]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[17]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[18]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[19]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[20]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[21]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[22]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[23]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[24]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[25]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[26]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[27]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[28]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[29]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[30]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[31]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[32]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[33]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[34]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[35]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[36]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[37]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[38]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[39]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[40]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[41]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[42]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[43]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[44]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[45]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[46]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[47]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[48]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[49]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[50]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[51]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[52]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[53]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[54]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[55]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[56]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[57]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[58]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[59]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[60]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[61]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[62]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[63]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[64]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[65]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[66]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[67]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[68]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[69]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[70]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[71]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[72]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[73]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[74]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[75]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[76]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[77]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[78]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[79]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[80]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[81]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[82]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePortEnable[83]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PciePtm|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieRelaxedOrdering|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieSlotOprom1|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieSlotOprom2|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieSlotOprom3|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieSlotOprom4|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieSlotOprom5|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieSlotOprom6|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieSlotOprom7|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PcieSlotOprom8|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PerformanceTuningMode|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.PostedInterrupt|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.SnoopResponseHoldOff|0x9
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[1]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[2]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[3]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[4]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[5]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[7]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[8]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[9]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[10]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[11]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[13]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[14]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[15]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[16]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[17]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[19]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[20]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[21]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[22]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[23]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[1]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[2]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[3]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[4]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[5]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[7]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[8]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[9]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[10]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[11]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[13]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[14]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[15]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[16]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[17]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[19]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[20]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[21]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[22]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[23]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[1]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[2]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[3]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[4]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[5]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[7]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[8]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[9]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[10]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[11]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[13]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[14]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[15]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[16]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[17]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[19]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[20]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[21]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[22]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[23]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[1]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[2]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[3]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[4]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[5]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[7]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[8]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[9]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[10]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[11]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[13]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[14]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[15]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[16]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[17]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[19]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[20]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[21]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[22]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[23]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[1]|0x14
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[2]|0x14
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[3]|0x14
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[4]|0x14
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[5]|0x14
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[7]|0x14
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[8]|0x14
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[9]|0x14
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[10]|0x14
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[11]|0x14
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[13]|0x14
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[14]|0x14
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[15]|0x14
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[16]|0x14
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[17]|0x14
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[19]|0x14
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[20]|0x14
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[21]|0x14
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[22]|0x14
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[23]|0x14
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VtdAcsWa|0x1
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig.MmiohBase|0x2
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig.MmiohSize|0x3
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig.MmcfgBase|0x6
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig.MmcfgSize|0x6
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig.IsocEn|0x2
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig.NumaEn|0x1
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig.ReservedS6|0xF
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig.ReservedS7[0]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig.ReservedS7[1]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig.ReservedS7[2]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig.ReservedS7[3]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig.ReservedS7[4]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig.ReservedS7[5]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig.ReservedS7[6]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig.ReservedS7[7]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig.ReservedS7[8]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig.ReservedS7[9]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig.ReservedS7[10]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig.ReservedS7[11]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig.ReservedS7[12]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig.ReservedS7[13]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig.ReservedS7[14]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig.ReservedS7[15]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig.ReservedS7[16]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig.ReservedS7[17]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig.ReservedS7[18]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig.ReservedS7[19]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig.ReservedS7[20]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig.ReservedS7[21]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig.ReservedS7[22]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig.ReservedS7[23]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig.ReservedS7[24]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig.ReservedS7[25]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig.ReservedS7[26]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig.ReservedS7[27]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig.ReservedS7[28]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig.ReservedS7[29]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig.ReservedS7[30]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketCommonRcConfig.ReservedS7[31]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.BusRatio[0]|0x1
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.BusRatio[1]|0x1
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.BusRatio[2]|0x1
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.BusRatio[3]|0x1
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.D2KCreditConfig|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.ReservedS154|0x5
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.ReservedS159|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.ReservedS176|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.ReservedS177|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.ReservedS181|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.ReservedS182|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.ReservedS180|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.ReservedS178|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.ReservedS179|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.ReservedS167|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.ReservedS168|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.ReservedS158|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.ReservedS164|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.ReservedS157|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.ReservedS163|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.ReservedS151|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.ReservedS156|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.ReservedS162|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.ReservedS152|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.ReservedS153|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.ReservedS169|0x8
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.ReservedS173|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.ReservedS160|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.ReservedS161|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.ReservedS170|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.ReservedS171|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.ReservedS172|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.ReservedS184|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.ReservedS174|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.ReservedS155|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.ReservedS165|0x1
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.ReservedS166|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.ReservedS175|0x5
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.DirectoryModeEn|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.IoDcMode|0x1
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.IrqThreshold|0x1
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.KtiAdaptationSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.KtiCrcMode|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.KtiFailoverEn|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.KtiLinkL0pEn|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.KtiLinkL1En|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.KtiPrefetchEn|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.KtiSkuMismatchCheck|0x1
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.LLCDeadLineAlloc|0x1
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.QpiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.QpiLinkSpeedMode|0x1
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.RdCurForXptPrefetchEn|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.StaleAtoSOptEn|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.TorThresLoctoremEmpty|0x1
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.TorThresLoctoremNorm|0x1
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.MbeBwCal|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.TscSyncEn|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.XptPrefetchEn|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.XptRemotePrefetchEn|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu0P0KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu0P0KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu0P1KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu0P1KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu0P2KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu0P2KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu0P3KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu0P3KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu0P4KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu0P4KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu0P5KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu0P5KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu1P0KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu1P0KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu1P1KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu1P1KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu1P2KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu1P2KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu1P3KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu1P3KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu1P4KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu1P4KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu1P5KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu1P5KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu2P0KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu2P0KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu2P1KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu2P1KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu2P2KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu2P2KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu2P3KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu2P3KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu2P4KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu2P4KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu2P5KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu2P5KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu3P0KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu3P0KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu3P1KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu3P1KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu3P2KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu3P2KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu3P3KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu3P3KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu3P4KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu3P4KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu3P5KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu3P5KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu0P0ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu0P0ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu0P0ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu0P0ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu0P1ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu0P1ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu0P1ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu0P1ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu0P2ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu0P2ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu0P2ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu0P2ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu0P3ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu0P3ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu0P3ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu0P3ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu0P4ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu0P4ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu0P4ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu0P4ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu0P5ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu0P5ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu0P5ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu0P5ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu1P0ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu1P0ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu1P0ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu1P0ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu1P1ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu1P1ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu1P1ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu1P1ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu1P2ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu1P2ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu1P2ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu1P2ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu1P3ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu1P3ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu1P3ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu1P3ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu1P4ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu1P4ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu1P4ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu1P4ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu1P5ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu1P5ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu1P5ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu1P5ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu2P0ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu2P0ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu2P0ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu2P0ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu2P1ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu2P1ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu2P1ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu2P1ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu2P2ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu2P2ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu2P2ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu2P2ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu2P3ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu2P3ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu2P3ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu2P3ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu2P4ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu2P4ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu2P4ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu2P4ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu2P5ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu2P5ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu2P5ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu2P5ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu3P0ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu3P0ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu3P0ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu3P0ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu3P1ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu3P1ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu3P1ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu3P1ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu3P2ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu3P2ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu3P2ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu3P2ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu3P3ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu3P3ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu3P3ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu3P3ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu3P4ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu3P4ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu3P4ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu3P4ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu3P5ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu3P5ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu3P5ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu3P5ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.AdddcErrInjEn|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ADRDataSaveMode|0x2
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ADREn|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.AdvMemTestCondition|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.AdvMemTestCondPause|0x186A0
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.AdvMemTestCondTrefi|0x3CF0
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.AdvMemTestCondTwr|0xA
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.AdvMemTestCondVdd|0x4EC
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.allowCorrectableMemTestError|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.AttemptFastBootCold|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS99|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS100|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS101|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS104|0x2
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS89|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS102|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS103|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS91|0x10
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS88|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS90|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS95|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS96|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS97|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS98|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.Blockgnt2cmd1cyc|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.CkeIdleTimer|0x14
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.CkMode|0x2
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.CmdNormalization|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.cmdSetupPercentOffset|0x32
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.CmdTxEqCalibration|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.CmsEnableDramPm|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.CustomRefreshRate|0x14
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.DataDllOff|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.DcpmmAveragePowerLimit|0x2EE0
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.DcpmmAveragePowerTimeConstant|0x6
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.DcpmmEccModeSwitch|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.DcpmmMbbAveragePowerTimeConstant|0x3A98
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.DcpmmMbbFeature|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.DcpmmMbbMaxPowerLimit|0x3A98
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.DdjcTraining|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.DdrMemoryType|0x2
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.DdrtCkeEn|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS48|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS83|0x2
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS122|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS121|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS120|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS136|0x2
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS63|0x7
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS62|0xF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS67|0x2
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS65|0x7FF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS66|0x40
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS73|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS109|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS78|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS68|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS110|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS57|0x7FF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS56|0x7FF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS61|0x1FF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS51|0x1F
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS52|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS50|0x40
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS60|0x3F
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS58|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS59|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS55|0x7FF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS53|0x7FF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS54|0x7FF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS108|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS70|0x2
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS79|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS117|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS118|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS140|0x0
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS141|0x0
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS142|0x0
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS75|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS80|0x4
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS149|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[0]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[1]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[2]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[3]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[4]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[5]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[12]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[13]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[14]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[15]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[16]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[17]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[24]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[25]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[26]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[27]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[28]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[29]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[36]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[37]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[38]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[39]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[40]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[41]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS64|0x7FF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS113|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS134|0x2
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS69|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS133|0x2
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.DieSparing|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.Disddrtopprd|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.DramRaplEnable|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.DramRaplExtendedRange|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.DramRaplPwrLimitLockCsr|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.DramRonEn|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.DutyCycleTraining|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.EccEnable|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.EccSupport|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.EliminateDirectoryInFarMemory|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS84|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS85|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.EnforcePopulationPor|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.EnforcePOR|0x2
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.eraseArmNVDIMMS|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.EsddcEn|0x2
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.FastGoConfig|0x6
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.FourxRefreshValue|0x5F
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.HalfxRefreshValue|0x19
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.haltOnMemErr|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.HwMemTest|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.iModeTraining|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.LatchSystemShutdownState|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.leakyBktHi|0x29
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.leakyBktHour|0x18
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.leakyBktLo|0x28
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.LrDimmBacksideVrefEn|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.LrDimmRdVrefEn|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.LrDimmRxDqCentering|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.LrDimmTxDqCentering|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.LrDimmWrVrefEn|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.LsxImplementation|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.McRonEn|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.MdllOffEn|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.mdllSden|0x2
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.MemCeFloodPolicy|0x2
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.memFlows|0xFFFFFFFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.memFlowsExt|0xFFFFFFFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.memFlowsExt2|0xFFFFFFFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.memFlowsExt3|0xFFFFFFFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.MemHotOuputAssertThreshold|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.memInterleaveGran1LM|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.MemTestLoops|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.multiSparingRanks|0x2
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.MultiThreaded|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.NgnArsPublish|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.NgnCmdTime|0x2
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.NgnEccCorr|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.NgnEccExitCorr|0x2
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.NgnEccRdChk|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.NgnEccWrChk|0x2
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.NonPreferredWayMask|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.normOppInterval|0x400
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.NvdimmSmbusMaxAccessTime|0x15E
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.NvdimmSmbusReleaseDelay|0x96
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.NvmdimmPowerCyclePolicy|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.NvmMediaStatusException|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.OffsetCmdAll|0x64
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.OffsetCmdVref|0x64
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.OffsetCtlAll|0x64
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.OffsetRxDq|0x64
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.OffsetRxVref|0x64
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.OffsetTxDq|0x64
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.OffsetTxVref|0x64
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.oneRankTimingMode|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.oppReadInWmm|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.PagePolicy|0x2
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.PatrolScrub|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.PatrolScrubAddrMode|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.PatrolScrubDuration|0x18
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.pda|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.PeriodicRcomp|0x2
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.PeriodicRcompInterval|0xF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.PkgcSrefEn|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.PpdEn|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.pprType|0x2
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.PreferredReadFirst|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.promoteMrcWarnings|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.promoteWarnings|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.PxcTraining|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.readVrefCenter|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.refreshMode|0x2
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.restoreNVDIMMS|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.RoundTripLatency|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.RxCtleTrnEn|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ScrambleEn|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ScrambleEnDDRT|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ScrambleSeedHigh|0xD395
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ScrambleSeedLow|0xA02B
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.smbSpeed|0x2
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.spareErrTh|0x7FFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.spdCrcCheck|0x2
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.Srat|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.Tap1End|0xA
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.Tap1Size|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.Tap1Start|0x8C
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.Tap2End|0xF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.Tap2Size|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.Tap2Start|0x73
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.Tap3End|0xC
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.Tap3Size|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.Tap3Start|0x70
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.Tap4End|0x9
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.Tap4Size|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.Tap4Start|0x6D
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.TempRefreshOption|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.thermalthrottlingsupport|0x2
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.TrefiNumofRank|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.turnaroundOpt|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.turnaroundOptDdrt|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.TwoxRefreshValue|0x53
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.txEqCalibration|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.Vdd|0x4B0
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.volMemMode|0x1
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.wrVrefCenter|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.CurrentLimit|0x438
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.EngAvgTimeWdw1|0x17
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PowerLimit1Time|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PowerLimit2Time|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.AcpiS3Enable|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.AcpiS4Enable|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.AltEngPerfBIAS|0x7
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.AvxIccpLevel|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.AvxSupport|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.C1AutoDemotion|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.C1AutoUnDemotion|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.ConfigTdpLock|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.EnablePkgcCriteria|0x2
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.EnablePkgCCriteriaMcddr[0]|0x2
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.EnablePkgCCriteriaMcddr[1]|0x2
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.EnablePkgCCriteriaMcddr[2]|0x2
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.EnablePkgCCriteriaMcddr[3]|0x2
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.EnableProcHot|0x3
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.EnableThermalMonitor|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.EnableXe|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.EnhancedPmaxDetector|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.FastRaplDutyCycle|0x40
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.GpssTimer|0x32
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti01pllOffEna[0]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti01pllOffEna[1]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti01pllOffEna[2]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti01pllOffEna[3]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti0In[0]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti0In[1]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti0In[2]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti0In[3]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti1In[0]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti1In[1]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti1In[2]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti1In[3]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti23pllOffEna[0]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti23pllOffEna[1]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti23pllOffEna[2]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti23pllOffEna[3]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti2In[0]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti2In[1]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti2In[2]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti2In[3]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti45pllOffEna[0]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti45pllOffEna[1]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti45pllOffEna[2]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti45pllOffEna[3]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.LTRSwInput|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Mc0pllOffEna[0]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Mc0pllOffEna[1]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Mc0pllOffEna[2]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Mc0pllOffEna[3]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Mc1pllOffEna[0]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Mc1pllOffEna[1]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Mc1pllOffEna[2]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Mc1pllOffEna[3]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.MonitorMWait|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.NativeAspmEnable|0x2
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.OverclockingLock|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.P0pllOffEna[0]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.P0pllOffEna[1]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.P0pllOffEna[2]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.P0pllOffEna[3]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.P0TtlTimeHigh1|0x3A
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.P0TtlTimeLow1|0x23
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.P1pllOffEna[0]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.P1pllOffEna[1]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.P1pllOffEna[2]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.P1pllOffEna[3]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.P2pllOffEna[0]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.P2pllOffEna[1]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.P2pllOffEna[2]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.P2pllOffEna[3]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PackageCState|0xFF
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio0In[0]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio0In[1]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio0In[2]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio0In[3]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio1In[0]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio1In[1]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio1In[2]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio1In[3]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio2In[0]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio2In[1]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio2In[2]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio2In[3]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio3In[0]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio3In[1]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio3In[2]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio3In[3]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio4In[0]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio4In[1]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio4In[2]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio4In[3]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio5In[0]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio5In[1]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio5In[2]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio5In[3]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcodeWdogTimerEn|0x2
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PerfPLimitClipC|0x1F
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PerfPlimitDifferential|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PerfPLimitEn|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PerfPLmtThshld|0xF
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PkgCCriteriaLogicalIpTypeIio[0]|0x20
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PkgCCriteriaLogicalIpTypeIio[1]|0x20
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PkgCCriteriaLogicalIpTypeIio[2]|0x20
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PkgCCriteriaLogicalIpTypeIio[3]|0x20
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PkgCCriteriaLogicalIpTypeMcddr[0]|0x10
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PkgCCriteriaLogicalIpTypeMcddr[1]|0x10
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PkgCCriteriaLogicalIpTypeMcddr[2]|0x10
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PkgCCriteriaLogicalIpTypeMcddr[3]|0x10
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PmaxDetector|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PowerLimit1En|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PowerLimit2En|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PpcccLock|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.ProcessorC1eEnable|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.ProcessorConfigurePbf|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.ProcessorEistEnable|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.ProcessorEPPEnable|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.ProcessorEppProfile|0x55
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.ProcessorHWPMEnable|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.ProchotLock|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PwrPerfSwitch|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.SapmCtlLock[0]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.SapmCtlLock[1]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.SapmCtlLock[2]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.SapmCtlLock[3]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.TurboMode|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.TurboPowerLimitCsrLock|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.TurboRatioLimitCores[0]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.TurboRatioLimitCores[1]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.TurboRatioLimitCores[2]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.TurboRatioLimitCores[3]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.TurboRatioLimitCores[4]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.TurboRatioLimitCores[5]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.TurboRatioLimitCores[6]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.TurboRatioLimitCores[7]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.UncrPerfPlmtOvrdEn|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PrmrrSize|0x80000000
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.AesEnable|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.BspSelection|0xFF
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.CheckCpuBist|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.CoreFailover|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.DCUIPPrefetcherEnable|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.DCUStreamerPrefetcherEnable|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.ReservedS245|0x2
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.ReservedS241|0x2
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.ReservedS242|0x2
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.ReservedS240|0x2
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.EpochUpdate|0x2
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.FastStringEnable|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.GlobalPsmiEnable|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.KeySplit|0x7
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.LockChipset|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.MachineCheckEnable|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.MlcSpatialPrefetcherEnable|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.MlcStreamerPrefetcherEnable|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.OclaMaxTorEntry[0]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.OclaMaxTorEntry[1]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.OclaMaxTorEntry[2]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.OclaMaxTorEntry[3]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.OclaMinWay[0]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.OclaMinWay[1]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.OclaMinWay[2]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.OclaMinWay[3]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PeciInTrustControlBit|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PpinControl|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.ProcessorFlexibleRatio|0x17
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.ProcessorVmxEnable|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiHandlerSize[0]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiHandlerSize[1]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiHandlerSize[2]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiHandlerSize[3]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion0[0]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion0[1]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion0[2]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion0[3]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion1[0]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion1[1]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion1[2]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion1[3]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion2[0]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion2[1]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion2[2]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion2[3]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion3[0]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion3[1]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion3[2]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion3[3]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion4[0]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion4[1]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion4[2]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion4[3]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.SgxAutoRegistrationAgent|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.SgxLeWr|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.SgxPackageInfoInBandAccess|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.SgxQoS|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.SmbusErrorRecovery|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.ThreeStrikeTimer|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.TsegSize|0x5
gStructPcdTokenSpaceGuid.PcdSetup.PcieCorErrThres|0x1
gStructPcdTokenSpaceGuid.PcdSetup.CpuVccInVoltage|0x167
gStructPcdTokenSpaceGuid.PcdSetup.SerialBaudRate|0x1C200
gStructPcdTokenSpaceGuid.PcdSetup.Gen12TimeWindow|0xFFFF
gStructPcdTokenSpaceGuid.PcdSetup.ReserveStartAddr|0x100000
gStructPcdTokenSpaceGuid.PcdSetup.BaudRate|0x5
gStructPcdTokenSpaceGuid.PcdSetup.ExpectedBer|0x7FFFFFFFF
gStructPcdTokenSpaceGuid.PcdSetup.XmlCliSupport|0x1
gStructPcdTokenSpaceGuid.PcdSetup.ApplicationProfile|0xFF
gStructPcdTokenSpaceGuid.PcdSetup.LomDisableByGpio|0x1
gStructPcdTokenSpaceGuid.PcdSetup.FpkPortConfig[0]|0x1
gStructPcdTokenSpaceGuid.PcdSetup.FpkPortConfig[1]|0x1
gStructPcdTokenSpaceGuid.PcdSetup.FpkPortConfig[2]|0x1
gStructPcdTokenSpaceGuid.PcdSetup.FpkPortConfig[3]|0x1
gStructPcdTokenSpaceGuid.PcdSetup.XhciWakeOnUsbEnabled|0x1
gStructPcdTokenSpaceGuid.PcdSetup.SystemErrorEn|0x1
gStructPcdTokenSpaceGuid.PcdSetup.RasLogLevel|0x1
gStructPcdTokenSpaceGuid.PcdSetup.PoisonEn|0x1
gStructPcdTokenSpaceGuid.PcdSetup.UboxToPcuMcaEn|0x1
gStructPcdTokenSpaceGuid.PcdSetup.EmcaEn|0x1
gStructPcdTokenSpaceGuid.PcdSetup.EmcaCsmiEn|0x2
gStructPcdTokenSpaceGuid.PcdSetup.CsmiDynamicDisable|0x1
gStructPcdTokenSpaceGuid.PcdSetup.EmcaMsmiEn|0x2
gStructPcdTokenSpaceGuid.PcdSetup.ElogCorrErrEn|0x1
gStructPcdTokenSpaceGuid.PcdSetup.ElogMemErrEn|0x1
gStructPcdTokenSpaceGuid.PcdSetup.ElogProcErrEn|0x1
gStructPcdTokenSpaceGuid.PcdSetup.LmceEn|0x1
gStructPcdTokenSpaceGuid.PcdSetup.WheaSupportEn|0x1
gStructPcdTokenSpaceGuid.PcdSetup.WheaLogMemoryEn|0x1
gStructPcdTokenSpaceGuid.PcdSetup.WheaLogProcEn|0x1
gStructPcdTokenSpaceGuid.PcdSetup.WheaLogPciEn|0x1
gStructPcdTokenSpaceGuid.PcdSetup.WheaErrInjEn|0x1
gStructPcdTokenSpaceGuid.PcdSetup.MemErrEn|0x1
gStructPcdTokenSpaceGuid.PcdSetup.CorrMemErrEn|0x1
gStructPcdTokenSpaceGuid.PcdSetup.SpareIntSelect|0x1
gStructPcdTokenSpaceGuid.PcdSetup.FnvErrorEn|0x1
gStructPcdTokenSpaceGuid.PcdSetup.FnvErrorLowPrioritySignal|0x1
gStructPcdTokenSpaceGuid.PcdSetup.FnvErrorHighPrioritySignal|0x1
gStructPcdTokenSpaceGuid.PcdSetup.NgnHostAlertPatrolScrubUNC|0x1
gStructPcdTokenSpaceGuid.PcdSetup.ReportAlertSPA|0x1
gStructPcdTokenSpaceGuid.PcdSetup.IioErrorEn|0x1
gStructPcdTokenSpaceGuid.PcdSetup.IoMcaEn|0x1
gStructPcdTokenSpaceGuid.PcdSetup.IioSev1Pcc|0x1
gStructPcdTokenSpaceGuid.PcdSetup.IioErrRegistersClearEn|0x1
gStructPcdTokenSpaceGuid.PcdSetup.DisableMAerrorLoggingDueToLER|0x1
gStructPcdTokenSpaceGuid.PcdSetup.EdpcInterrupt|0x1
gStructPcdTokenSpaceGuid.PcdSetup.EdpcErrCorMsg|0x1
gStructPcdTokenSpaceGuid.PcdSetup.IioIrpErrorEn|0x1
gStructPcdTokenSpaceGuid.PcdSetup.IioMiscErrorEn|0x1
gStructPcdTokenSpaceGuid.PcdSetup.IioVtdErrorEn|0x1
gStructPcdTokenSpaceGuid.PcdSetup.IioDmaErrorEn|0x1
gStructPcdTokenSpaceGuid.PcdSetup.IioDmiErrorEn|0x1
gStructPcdTokenSpaceGuid.PcdSetup.IioPcieAddCorrErrorEn|0x1
gStructPcdTokenSpaceGuid.PcdSetup.IioPcieAddUnCorrEn|0x1
gStructPcdTokenSpaceGuid.PcdSetup.PsfUrEnable|0x1
gStructPcdTokenSpaceGuid.PcdSetup.PmsbRouterParityErrEn|0x1
gStructPcdTokenSpaceGuid.PcdSetup.PcieErrEn|0x1
gStructPcdTokenSpaceGuid.PcdSetup.PcieCorrErrEn|0x1
gStructPcdTokenSpaceGuid.PcdSetup.PcieUncorrErrEn|0x1
gStructPcdTokenSpaceGuid.PcdSetup.PcieFatalErrEn|0x1
gStructPcdTokenSpaceGuid.PcdSetup.PcieAerCorrErrEn|0x1
gStructPcdTokenSpaceGuid.PcdSetup.PcieAerNfatErrEn|0x1
gStructPcdTokenSpaceGuid.PcdSetup.PcieAerFatErrEn|0x1
gStructPcdTokenSpaceGuid.PcdSetup.PcieAerEcrcEn|0x1
gStructPcdTokenSpaceGuid.PcdSetup.McBankWarmBootClearError|0x1
gStructPcdTokenSpaceGuid.PcdSetup.irpp0_parityError|0x1
gStructPcdTokenSpaceGuid.PcdSetup.irpp0_qtOverflow|0x1
gStructPcdTokenSpaceGuid.PcdSetup.irpp0_unexprsp|0x1
gStructPcdTokenSpaceGuid.PcdSetup.irpp0_csraccunaligned|0x1
gStructPcdTokenSpaceGuid.PcdSetup.irpp0_unceccCs1|0x1
gStructPcdTokenSpaceGuid.PcdSetup.irpp0_unceccCs0|0x1
gStructPcdTokenSpaceGuid.PcdSetup.irpp0_rcvdpoison|0x1
gStructPcdTokenSpaceGuid.PcdSetup.irpp0_crreccCs1|0x1
gStructPcdTokenSpaceGuid.PcdSetup.irpp0_crreccCs0|0x1
gStructPcdTokenSpaceGuid.PcdSetup.PropagateSerr|0x1
gStructPcdTokenSpaceGuid.PcdSetup.PropagatePerr|0x1
gStructPcdTokenSpaceGuid.PcdSetup.Use1GPageTable|0x1
gStructPcdTokenSpaceGuid.PcdSetup.UsbMassResetDelay|0x1
gStructPcdTokenSpaceGuid.PcdSetup.ConsoleRedirection|0x1
gStructPcdTokenSpaceGuid.PcdSetup.LegacyOsRedirection|0x1
gStructPcdTokenSpaceGuid.PcdSetup.DataBits|0x8
gStructPcdTokenSpaceGuid.PcdSetup.Parity|0x1
gStructPcdTokenSpaceGuid.PcdSetup.StopBits|0x1
gStructPcdTokenSpaceGuid.PcdSetup.ARIEnable|0x1
gStructPcdTokenSpaceGuid.PcdSetup.SRIOVEnable|0x1
gStructPcdTokenSpaceGuid.PcdSetup.SvidEnable|0x1
gStructPcdTokenSpaceGuid.PcdSetup.FivrFaultsEnable|0x1
gStructPcdTokenSpaceGuid.PcdSetup.FivrEfficiencyEnable|0x1
gStructPcdTokenSpaceGuid.PcdSetup.ReservedS2|0x2
gStructPcdTokenSpaceGuid.PcdSetup.ReservedS3|0x2
gStructPcdTokenSpaceGuid.PcdSetup.Gen34TimeWindow|0x2
gStructPcdTokenSpaceGuid.PcdSetup.Gen34ErrorThreshold|0x10
gStructPcdTokenSpaceGuid.PcdSetup.Gen34ReEqualization|0x1
gStructPcdTokenSpaceGuid.PcdSetup.Gen2LinkDegradation|0x1
gStructPcdTokenSpaceGuid.PcdSetup.Gen3LinkDegradation|0x1
gStructPcdTokenSpaceGuid.PcdSetup.Gen4LinkDegradation|0x1
gStructPcdTokenSpaceGuid.PcdSetup.Ce2LmLoggingEn|0x1
gStructPcdTokenSpaceGuid.PcdSetup.KtiFirstCeLatchEn|0x1
gStructPcdTokenSpaceGuid.PcdSetup.PatrolScrubErrorReporting|0x0
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideValue[0]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideValue[1]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideValue[2]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideValue[3]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideValue[4]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideValue[5]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideValue[6]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideValue[7]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideValue[8]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideValue[9]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideValue[10]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideValue[11]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideValue[12]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideValue[13]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideValue[14]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideValue[15]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideValue[16]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideValue[17]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideValue[18]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideValue[19]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideValue[0]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideValue[1]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideValue[2]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideValue[3]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideValue[4]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideValue[5]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideValue[6]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideValue[7]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideValue[8]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideValue[9]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideValue[10]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideValue[11]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideValue[12]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideValue[13]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideValue[14]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideValue[15]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideValue[16]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideValue[17]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideValue[18]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideValue[19]|0x3C
gStructPcdTokenSpaceGuid.PcdPchSetup.PchSataSnoopLatencyOverrideValue|0x28
gStructPcdTokenSpaceGuid.PcdPchSetup.PchSSataSnoopLatencyOverrideValue|0x28
gStructPcdTokenSpaceGuid.PcdPchSetup.AdrMultiplierVal|0x63
gStructPcdTokenSpaceGuid.PcdPchSetup.AdrTimerVal|0x4
gStructPcdTokenSpaceGuid.PcdPchSetup.Btcg|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.Dwr_BmcRootPort|0x5
gStructPcdTokenSpaceGuid.PcdPchSetup.Dwr_IeResetPrepDone|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.Dwr_MeResetPrepDone|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.DwrEn_PMCGBL|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchBiosLock|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchCrossThrottling|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchEvaLockDown|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchEvaMrom0HookEnable|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchEvaMrom1HookEnable|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchGpioLockDown|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchHdAudio|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieGlobalAspm|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieLtrEnable[0]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieLtrEnable[1]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieLtrEnable[2]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieLtrEnable[3]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieLtrEnable[4]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieLtrEnable[5]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieLtrEnable[6]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieLtrEnable[7]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieLtrEnable[8]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieLtrEnable[9]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieLtrEnable[10]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieLtrEnable[11]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieLtrEnable[12]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieLtrEnable[13]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieLtrEnable[14]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieLtrEnable[15]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieLtrEnable[16]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieLtrEnable[17]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieLtrEnable[18]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieLtrEnable[19]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMode[0]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMode[1]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMode[2]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMode[3]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMode[4]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMode[5]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMode[6]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMode[7]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMode[8]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMode[9]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMode[10]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMode[11]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMode[12]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMode[13]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMode[14]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMode[15]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMode[16]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMode[17]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMode[18]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMode[19]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMultiplier[0]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMultiplier[1]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMultiplier[2]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMultiplier[3]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMultiplier[4]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMultiplier[5]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMultiplier[6]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMultiplier[7]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMultiplier[8]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMultiplier[9]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMultiplier[10]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMultiplier[11]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMultiplier[12]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMultiplier[13]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMultiplier[14]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMultiplier[15]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMultiplier[16]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMultiplier[17]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMultiplier[18]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieNonSnoopLatencyOverrideMultiplier[19]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMode[0]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMode[1]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMode[2]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMode[3]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMode[4]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMode[5]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMode[6]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMode[7]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMode[8]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMode[9]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMode[10]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMode[11]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMode[12]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMode[13]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMode[14]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMode[15]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMode[16]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMode[17]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMode[18]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMode[19]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMultiplier[0]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMultiplier[1]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMultiplier[2]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMultiplier[3]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMultiplier[4]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMultiplier[5]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMultiplier[6]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMultiplier[7]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMultiplier[8]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMultiplier[9]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMultiplier[10]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMultiplier[11]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMultiplier[12]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMultiplier[13]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMultiplier[14]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMultiplier[15]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMultiplier[16]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMultiplier[17]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMultiplier[18]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieSnoopLatencyOverrideMultiplier[19]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieUX16MaxPayloadSize|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchPcieUX8MaxPayloadSize|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchRtcLock|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchSata|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchSataLtrConfigLock|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchSataLtrEnable|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchSataSnoopLatencyOverrideMultiplier|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchSlpLanLowDc|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchsSata|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchSSataLtrConfigLock|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchSSataLtrEnable|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchSSataSnoopLatencyOverrideMultiplier|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchTraceHubHide|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchTraceHubMode|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PchUsbHsPort[0]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchUsbHsPort[1]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchUsbHsPort[2]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchUsbHsPort[3]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchUsbHsPort[4]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchUsbHsPort[5]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchUsbHsPort[6]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchUsbHsPort[7]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchUsbHsPort[8]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchUsbHsPort[9]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchUsbHsPort[10]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchUsbHsPort[11]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchUsbHsPort[12]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchUsbHsPort[13]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchUsbSsPort[0]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchUsbSsPort[1]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchUsbSsPort[2]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchUsbSsPort[3]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchUsbSsPort[4]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchUsbSsPort[5]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchUsbSsPort[6]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchUsbSsPort[7]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchUsbSsPort[8]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PchUsbSsPort[9]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCm[0]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCm[1]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCm[2]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCm[3]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCm[4]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCm[5]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCm[6]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCm[7]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCm[8]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCm[9]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCm[10]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCm[11]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCm[12]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCm[13]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCm[14]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCm[15]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCm[16]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCm[17]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCm[18]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCm[19]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCp[0]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCp[1]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCp[2]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCp[3]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCp[4]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCp[5]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCp[6]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCp[7]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCp[8]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCp[9]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCp[10]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCp[11]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCp[12]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCp[13]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCp[14]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCp[15]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCp[16]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCp[17]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCp[18]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieLaneCp[19]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PciePllSsc|0xFE
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortACS[0]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortACS[1]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortACS[2]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortACS[3]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortACS[4]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortACS[5]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortACS[6]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortACS[7]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortACS[8]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortACS[9]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortACS[10]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortACS[11]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortACS[12]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortACS[13]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortACS[14]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortACS[15]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortACS[16]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortACS[17]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortACS[18]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortACS[19]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortAER[0]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortAER[1]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortAER[2]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortAER[3]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortAER[4]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortAER[5]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortAER[6]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortAER[7]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortAER[8]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortAER[9]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortAER[10]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortAER[11]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortAER[12]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortAER[13]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortAER[14]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortAER[15]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortAER[16]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortAER[17]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortAER[18]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortAER[19]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEn[0]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEn[1]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEn[2]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEn[3]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEn[4]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEn[5]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEn[6]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEn[7]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEn[8]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEn[9]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEn[10]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEn[11]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEn[12]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEn[13]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEn[14]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEn[15]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEn[16]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEn[17]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEn[18]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEn[19]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEqPh3Method[0]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEqPh3Method[1]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEqPh3Method[2]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEqPh3Method[3]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEqPh3Method[4]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEqPh3Method[5]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEqPh3Method[6]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEqPh3Method[7]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEqPh3Method[8]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEqPh3Method[9]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEqPh3Method[10]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEqPh3Method[11]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEqPh3Method[12]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEqPh3Method[13]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEqPh3Method[14]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEqPh3Method[15]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEqPh3Method[16]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEqPh3Method[17]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEqPh3Method[18]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortEqPh3Method[19]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortFunctionSwapping|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortL1SubStates[0]|0x3
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortL1SubStates[1]|0x3
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortL1SubStates[2]|0x3
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortL1SubStates[3]|0x3
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortL1SubStates[4]|0x3
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortL1SubStates[5]|0x3
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortL1SubStates[6]|0x3
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortL1SubStates[7]|0x3
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortL1SubStates[8]|0x3
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortL1SubStates[9]|0x3
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortL1SubStates[10]|0x3
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortL1SubStates[11]|0x3
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortL1SubStates[12]|0x3
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortL1SubStates[13]|0x3
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortL1SubStates[14]|0x3
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortL1SubStates[15]|0x3
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortL1SubStates[16]|0x3
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortL1SubStates[17]|0x3
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortL1SubStates[18]|0x3
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortL1SubStates[19]|0x3
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieRootPortMaxReadRequestSize|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieSwEqCoeffCm[0]|0x6
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieSwEqCoeffCm[1]|0x4
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieSwEqCoeffCm[2]|0x8
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieSwEqCoeffCm[3]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieSwEqCoeffCm[4]|0xA
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieSwEqCoeffCp[0]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieSwEqCoeffCp[1]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieSwEqCoeffCp[2]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieSwEqCoeffCp[3]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PcieSwEqCoeffCp[4]|0x2
gStructPcdTokenSpaceGuid.PcdPchSetup.PmcReadDisable|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.SataHddlk|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.SataLedl|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.SataMechanicalSw[0]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.SataMechanicalSw[1]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.SataMechanicalSw[2]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.SataMechanicalSw[3]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.SataMechanicalSw[4]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.SataMechanicalSw[5]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.SataMechanicalSw[6]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.SataMechanicalSw[7]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.SataPort[0]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.SataPort[1]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.SataPort[2]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.SataPort[3]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.SataPort[4]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.SataPort[5]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.SataPort[6]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.SataPort[7]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.SataRaidIooe|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.SataRaidIrrt|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.SataRaidOub|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.SataRaidR0|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.SataRaidR1|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.SataRaidR10|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.SataRaidR5|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.SataRaidSrt|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.SataSalp|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.sSataHddlk|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.sSataLedl|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.sSataPort[0]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.sSataPort[1]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.sSataPort[2]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.sSataPort[3]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.sSataPort[4]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.sSataPort[5]|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.sSataRaidIooe|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.sSataRaidIrrt|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.sSataRaidOub|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.sSataRaidR0|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.sSataRaidR1|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.sSataRaidR10|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.sSataRaidR5|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.sSataRaidSrt|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.sSataSalp|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.TestSmbusSpdWriteDisable|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.ThermalDeviceEnable|0x3
gStructPcdTokenSpaceGuid.PcdPchSetup.Usb3PinsTermination|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.XhciIdleL1|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.XhciOcMapEnabled|0x1
gStructPcdTokenSpaceGuid.PcdPchSetup.XTpmLen|0x1
gStructPcdTokenSpaceGuid.PcdFpgaSocketConfig.FpgaSetupEnabled|0x3
gStructPcdTokenSpaceGuid.PcdFpgaSocketConfig.FpgaThermalTH1[0]|0x5A
gStructPcdTokenSpaceGuid.PcdFpgaSocketConfig.FpgaThermalTH1[1]|0x5A
gStructPcdTokenSpaceGuid.PcdFpgaSocketConfig.FpgaThermalTH2[0]|0x5D
gStructPcdTokenSpaceGuid.PcdFpgaSocketConfig.FpgaThermalTH2[1]|0x5D

!if $(MAX_SOCKET) > 4
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[32]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[33]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[34]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[35]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[36]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[37]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[38]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[39]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[40]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[41]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[42]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[43]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[44]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[45]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[46]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[47]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[48]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[49]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[50]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[51]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[52]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[53]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[54]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[55]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[56]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[57]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[58]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[59]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[60]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[61]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[62]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.Cb3DmaEn[63]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[25]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[26]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[27]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[28]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[29]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[31]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[32]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[33]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[34]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[35]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[37]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[38]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[39]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[40]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[41]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[43]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[44]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[45]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[46]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarAttr[47]|0x2
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[25]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[26]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[27]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[28]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[29]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[31]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[32]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[33]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[34]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[35]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[37]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[38]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[39]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[40]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[41]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[43]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[44]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[45]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[46]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDCfgBarSz[47]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[25]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[26]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[27]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[28]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[29]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[31]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[32]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[33]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[34]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[35]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[37]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[38]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[39]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[40]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[41]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[43]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[44]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[45]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[46]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBar2Attr[47]|0x1
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[25]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[26]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[27]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[28]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[29]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[31]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[32]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[33]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[34]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[35]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[37]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[38]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[39]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[40]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[41]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[43]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[44]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[45]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[46]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz1[47]|0x19
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[25]|0x14
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[26]|0x14
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[27]|0x14
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[28]|0x14
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[29]|0x14
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[31]|0x14
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[32]|0x14
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[33]|0x14
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[34]|0x14
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[35]|0x14
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[37]|0x14
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[38]|0x14
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[39]|0x14
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[40]|0x14
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[41]|0x14
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[43]|0x14
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[44]|0x14
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[45]|0x14
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[46]|0x14
gStructPcdTokenSpaceGuid.PcdSocketIioConfig.VMDMemBarSz2[47]|0x14
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.BusRatio[4]|0x1
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.BusRatio[5]|0x1
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.BusRatio[6]|0x1
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.BusRatio[7]|0x1
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu4P0KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu4P0KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu4P1KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu4P1KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu4P2KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu4P2KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu4P3KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu4P3KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu4P4KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu4P4KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu4P5KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu4P5KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu5P0KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu5P0KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu5P1KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu5P1KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu5P2KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu5P2KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu5P3KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu5P3KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu5P4KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu5P4KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu5P5KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu5P5KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu6P0KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu6P0KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu6P1KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu6P1KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu6P2KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu6P2KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu6P3KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu6P3KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu6P4KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu6P4KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu6P5KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu6P5KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu7P0KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu7P0KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu7P1KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu7P1KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu7P2KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu7P2KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu7P3KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu7P3KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu7P4KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu7P4KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu7P5KtiLinkSpeed|0x3
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu7P5KtiLinkVnaOverride|0x7F
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu4P0ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu4P0ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu4P0ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu4P0ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu4P1ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu4P1ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu4P1ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu4P1ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu4P2ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu4P2ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu4P2ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu4P2ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu4P3ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu4P3ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu4P3ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu4P3ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu4P4ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu4P4ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu4P4ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu4P4ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu4P5ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu4P5ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu4P5ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu4P5ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu5P0ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu5P0ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu5P0ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu5P0ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu5P1ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu5P1ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu5P1ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu5P1ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu5P2ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu5P2ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu5P2ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu5P2ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu5P3ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu5P3ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu5P3ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu5P3ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu5P4ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu5P4ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu5P4ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu5P4ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu5P5ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu5P5ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu5P5ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu5P5ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu6P0ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu6P0ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu6P0ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu6P0ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu6P1ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu6P1ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu6P1ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu6P1ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu6P2ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu6P2ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu6P2ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu6P2ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu6P3ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu6P3ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu6P3ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu6P3ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu6P4ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu6P4ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu6P4ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu6P4ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu6P5ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu6P5ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu6P5ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu6P5ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu7P0ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu7P0ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu7P0ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu7P0ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu7P1ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu7P1ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu7P1ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu7P1ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu7P2ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu7P2ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu7P2ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu7P2ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu7P3ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu7P3ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu7P3ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu7P3ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu7P4ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu7P4ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu7P4ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu7P4ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu7P5ReservedS189|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu7P5ReservedS190|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu7P5ReservedS191|0x2
gStructPcdTokenSpaceGuid.PcdSocketMpLinkConfig.Cpu7P5ReservedS246|0x2
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[48]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[49]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[50]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[51]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[52]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[53]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[60]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[61]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[62]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[63]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[64]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[65]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[72]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[73]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[74]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[75]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[76]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[77]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[84]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[85]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[86]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[87]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[88]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketMemoryConfig.ReservedS81[89]|0xFF
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.EnablePkgCCriteriaMcddr[4]|0x2
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.EnablePkgCCriteriaMcddr[5]|0x2
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.EnablePkgCCriteriaMcddr[6]|0x2
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.EnablePkgCCriteriaMcddr[7]|0x2
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti01pllOffEna[4]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti01pllOffEna[5]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti01pllOffEna[6]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti01pllOffEna[7]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti0In[4]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti0In[5]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti0In[6]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti0In[7]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti1In[4]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti1In[5]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti1In[6]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti1In[7]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti23pllOffEna[4]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti23pllOffEna[5]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti23pllOffEna[6]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti23pllOffEna[7]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti2In[4]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti2In[5]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti2In[6]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti2In[7]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti45pllOffEna[4]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti45pllOffEna[5]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti45pllOffEna[6]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Kti45pllOffEna[7]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Mc0pllOffEna[4]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Mc0pllOffEna[5]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Mc0pllOffEna[6]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Mc0pllOffEna[7]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Mc1pllOffEna[4]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Mc1pllOffEna[5]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Mc1pllOffEna[6]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.Mc1pllOffEna[7]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.P0pllOffEna[4]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.P0pllOffEna[5]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.P0pllOffEna[6]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.P0pllOffEna[7]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.P1pllOffEna[4]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.P1pllOffEna[5]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.P1pllOffEna[6]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.P1pllOffEna[7]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.P2pllOffEna[4]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.P2pllOffEna[5]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.P2pllOffEna[6]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.P2pllOffEna[7]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio0In[4]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio0In[5]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio0In[6]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio0In[7]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio1In[4]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio1In[5]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio1In[6]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio1In[7]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio2In[4]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio2In[5]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio2In[6]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio2In[7]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio3In[4]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio3In[5]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio3In[6]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio3In[7]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio4In[4]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio4In[5]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio4In[6]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio4In[7]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio5In[4]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio5In[5]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio5In[6]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PcieIio5In[7]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PkgCCriteriaLogicalIpTypeIio[4]|0x20
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PkgCCriteriaLogicalIpTypeIio[5]|0x20
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PkgCCriteriaLogicalIpTypeIio[6]|0x20
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PkgCCriteriaLogicalIpTypeIio[7]|0x20
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PkgCCriteriaLogicalIpTypeMcddr[4]|0x10
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PkgCCriteriaLogicalIpTypeMcddr[5]|0x10
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PkgCCriteriaLogicalIpTypeMcddr[6]|0x10
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.PkgCCriteriaLogicalIpTypeMcddr[7]|0x10
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.SapmCtlLock[4]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.SapmCtlLock[5]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.SapmCtlLock[6]|0x1
gStructPcdTokenSpaceGuid.PcdSocketPowerManagementConfig.SapmCtlLock[7]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.OclaMaxTorEntry[4]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.OclaMaxTorEntry[5]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.OclaMaxTorEntry[6]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.OclaMaxTorEntry[7]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.OclaMinWay[4]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.OclaMinWay[5]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.OclaMinWay[6]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.OclaMinWay[7]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiHandlerSize[4]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiHandlerSize[5]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiHandlerSize[6]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiHandlerSize[7]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion0[4]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion0[5]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion0[6]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion0[7]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion1[4]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion1[5]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion1[6]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion1[7]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion2[4]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion2[5]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion2[6]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion2[7]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion3[4]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion3[5]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion3[6]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion3[7]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion4[4]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion4[5]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion4[6]|0x1
gStructPcdTokenSpaceGuid.PcdSocketProcessorCoreConfig.PsmiTraceBufferSizeRegion4[7]|0x1
!endif
